import KeyMirror from 'keymirror';

export const appConfig = {
  serverBaseUrl: 'http://localhost:8000/',

  // development
  logApiCalls: true,
};

export const stateModes = KeyMirror({
  IDLE: null,
  PENDING: null,
  SUCCESS: null,
  FAIL: null,
});

/* eslint-disable import/prefer-default-export */
export const ActionTypes = KeyMirror({
  APP_STATE_SET_IS_INITIATED: null,
  APP_STATE_SET_IS_LOGGED_IN: null,
  APP_STATE_SET_IS_USER_VERIFIED: null,
  APP_STATE_SET_APP_PAGE: null,

  AUDIO_PLAYER_SET_URL: null,
  AUDIO_PLAYER_SET_POST_ID: null,
  AUDIO_PLAYER_SET_IS_PLAYING: null,
  AUDIO_PLAYER_SET_CURRENT_TIME_HANDLER: null,
  AUDIO_PLAYER_SEEK_CURRENT_TIME: null,

  CURRENT_USER_SET_CURRENT_USER: null,
  CURRENT_USER_REMOVE_CURRENT_USER: null,
  CURRENT_USER_SET_AUTH_TOKEN: null,
  CURRENT_USER_REMOVE_AUTH_TOKEN: null,
  CURRENT_USER_REMOVE_CURRENT_USER_FOLLOWERS: null,
  CURRENT_USER_REMOVE_CURRENT_USER_FOLLOWING: null,
  CURRENT_USER_SET_CURRENT_USER_FOLLOWERS: null,
  CURRENT_USER_SET_CURRENT_USER_FOLLOWING: null,
  CURRENT_USER_ADD_CURRENT_USER_FOLLOWERS: null,
  CURRENT_USER_ADD_CURRENT_USER_FOLLOWING: null,
  CURRENT_USER_SET_NEXT_FOLLOWING: null,
  CURRENT_USER_SET_NEXT_FOLLOWERS: null,
  CURRENT_USER_REMOVE_USER_FOLLOWER: null,
  CURRENT_USER_REMOVE_USER_FOLLOWING: null,

  LIKER_LIST_MODAL_OPEN: null,
  LIKER_LIST_MODAL_CLOSE: null,
  LIKER_LIST_MODAL_SET_LIKER_LIST: null,

  LOGIN_SET_IS_LOGGED_IN: null,
  LOGIN_ERROR: null,
  LOGIN_SET_PENDING: null,

  VERIFICATION_MODAL_OPEN: null,
  VERIFICATION_MODAL_CLOSE: null,

  REPLY_MODAL_OPEN: null,
  REPLY_MODAL_CLOSE: null,

  SEARCH_SET_IS_OPEN: null,
  SEARCH_SET_IS_LOADING: null,
  SEARCH_SET_NO_RESULTS: null,
  SEARCH_SET_QUERY: null,
  SEARCH_SET_RESULTS: null,
  SEARCH_APPEND_RESULTS: null,
  SEARCH_SET_NEXT_PAGE_URL: null,

  SIGNUP_SERVER_ERROR: null,
  SIGNUP_SET_PENDING: null,
  SIGNUP_SET_COUNTRY_LIST: null,
  SIGNUP_SET_USERNAME_AVAILABLE: null,
  SIGNUP_SET_EMAIL_AVAILABLE: null,

  POST_DETAIL_SET_POST: null,
  POST_DETAIL_SET_COMMENT_LIST: null,
  POST_DETAIL_SET_LIKERS_LIST: null,
  POST_DETAIL_IS_POST_LOADING: null,
  POST_DETAIL_ARE_COMMENTS_LOADING: null,

  PROFILE_SET_POSTS: null,
  PROFILE_APPEND_POSTS: null,
  PROFILE_SET_NEXT_PAGE_URL: null,

  VERIFICATION_SET_CODE: null,
  VERIFICATION_SET_ERROR: null,
  VERIFICATION_SET_PENDING: null,

  VISITED_USER_SET_VISITED_USER: null,
  VISITED_USER_SET_VISITED_USER_FOLLOWERS: null,
  VISITED_USER_SET_VISITED_USER_FOLLOWING: null,
  VISITED_USER_SET_VISITED_USER_ERROR: null,
  VISITED_USER_SET_NEXT_FOLLOWING_PAGE: null,
  VISITED_USER_SET_NEXT_FOLLOWERS_PAGE: null,
  VISITED_USER_ADD_VISITED_USER_FOLLOWERS: null,
  VISITED_USER_ADD_VISITED_USER_FOLLOWING: null,

  TIMELINE_SET_POSTS: null,
  TIMELINE_APPEND_POSTS: null,
  TIMELINE_SET_NEXT_PAGE_URL: null,

  SAGA_ON_LOGIN: null,
  SAGA_AUTHENTICATE: null,
  SAGA_SIGN_OUT: null,
  SAGA_SIGNUP: null,
  SAGA_UPDATE_COUNTRY_LIST: null,
  SAGA_CHECK_USERNAME_AVAILABILITY: null,
  SAGA_CHECK_EMAIL_AVAILABILITY: null,
  SAGA_RESEND_VERIFY_EMAIL: null,
  SAGA_VERIFY_USER: null,
  SAGA_CREATE_POST: null,
  SAGA_VISITED_USER: null,
  SAGA_VISITED_USER_GET_FOLLOWERS: null,
  SAGA_VISITED_USER_GET_FOLLOWING: null,
  SAGA_VISITED_USER_GET_NEXT_FOLLOWERS: null,
  SAGA_VISITED_USER_GET_NEXT_FOLLOWING: null,
  SAGA_CREATE_COMMENT: null,
  SAGA_DELETE_POST: null,
  SAGA_LIKE_POST: null,
  SAGA_UNLIKE_POST: null,
  SAGA_GET_USER_POSTS: null,
  SAGA_LOAD_TIMELINE_POSTS: null,
  SAGA_GET_POST_COMMENTS: null,
  SAGA_GET_POST: null,
  SAGA_GET_POST_LIKER_LIST: null,
  SAGA_UPDATE_SEARCH_RESULTS: null,
  SAGA_TIMELINE_LOAD_MORE: null,
  SAGA_SEARCH_LOAD_MORE: null,
  SAGA_FOLLOW_FOLLOW_USER: null,
  SAGA_FOLLOW_UNFOLLOW_USER: null,
  SAGA_CURRENT_USER_GET_ALL_USER_FOLLOWRS: null,
  SAGA_CURRENT_USER_GET_ALL_USER_FOLLOWING: null,
  SAGA_LOAD_PROFILE_POSTS: null,
  SAGA_PROFILE_POST_LOAD_MORE: null,

});

export const voiceSetting = {
  MAXIMUM_VOICE_LENGTH_MS: 60000,
  MAXIMUM_AUDIO_FILE_BYTES: 10485760,
};

export const appPages = KeyMirror({
  HOME: null,
  PROFILE: null,
  SETTING: null,
});

export const fieldRegex = {
  usernameRegex: /^[a-zA-Z0-9+-._]+$/,
  // eslint-disable-next-line no-useless-escape
  emailRegex: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
  onlyNumberRegex: /^[0-9]+$/,
  phoneNumberRegex: /^\+?[1-9]\d{1,14}$/,
};
